<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: io/readinp.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_7dc76e12c3f74bb85b7effb3b7dc07e4.html">io</a>
  </div>
</div>
<div class="contents">
<h1>readinp.c</h1><a href="readinp_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: readinp.c 2988 2010-03-01 17:46:55Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="magpario_8h.html">magpario.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">/* Reads grid and/or data from AVS INP file */</span>
<a name="l00030"></a>00030 
<a name="l00031"></a><a class="code" href="readinp_8c.html#ac48e244b5ec28e4a0d8a7ce8596bbe76">00031</a> <span class="keywordtype">int</span> <a class="code" href="magpario_8h.html#ac48e244b5ec28e4a0d8a7ce8596bbe76">ReadINP</a>(<a class="code" href="structGridData.html">GridData</a> *gdata, <span class="keywordtype">char</span> *fmesh, Vec Vdest, <span class="keywordtype">int</span> col)
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033   <span class="keywordtype">int</span>          i,j;
<a name="l00034"></a>00034 
<a name="l00035"></a>00035   <span class="keywordtype">char</span>         msg[256];
<a name="l00036"></a>00036   FILE         *fd;
<a name="l00037"></a>00037 
<a name="l00038"></a>00038   <span class="keywordtype">int</span>          a1;
<a name="l00039"></a>00039   <span class="keywordtype">int</span>          id, n1, n2, n3, n4, n5;
<a name="l00040"></a>00040   <span class="keywordtype">int</span>          n_ele;
<a name="l00041"></a>00041   <span class="keywordtype">int</span>          t_dnv;
<a name="l00042"></a>00042   PetscReal    d1,d2,d3;
<a name="l00043"></a>00043 
<a name="l00044"></a>00044   PetscTruth   flg;
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00047"></a>00047   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00048"></a>00048 
<a name="l00049"></a>00049   <span class="keywordtype">int</span> rank,size;
<a name="l00050"></a>00050   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00051"></a>00051   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00052"></a>00052 
<a name="l00053"></a>00053   <span class="comment">/* check if we are supposed to read vertex data */</span>
<a name="l00054"></a>00054   <span class="keywordflow">if</span> (Vdest!=PETSC_NULL &amp;&amp; col&gt;0) {
<a name="l00055"></a>00055     ierr = VecValid(Vdest,&amp;flg);CHKERRQ(ierr);
<a name="l00056"></a>00056     <span class="keywordflow">if</span> (flg!=PETSC_TRUE) col=0;
<a name="l00057"></a>00057   }
<a name="l00058"></a>00058   <span class="keywordflow">else</span> {
<a name="l00059"></a>00059     col=0;
<a name="l00060"></a>00060   }
<a name="l00061"></a>00061 
<a name="l00062"></a>00062   <span class="keywordflow">if</span> (rank) {
<a name="l00063"></a>00063     gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>=0;
<a name="l00064"></a>00064     gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>=0;
<a name="l00065"></a>00065 
<a name="l00066"></a>00066     <span class="keywordflow">if</span> (col&gt;0) {
<a name="l00067"></a>00067       VecAssemblyBegin(Vdest);
<a name="l00068"></a>00068       VecAssemblyEnd(Vdest);
<a name="l00069"></a>00069     }
<a name="l00070"></a>00070 
<a name="l00071"></a>00071     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00072"></a>00072   }
<a name="l00073"></a>00073 
<a name="l00074"></a>00074   ierr = PetscFOpen(PETSC_COMM_WORLD,fmesh,<span class="stringliteral">&quot;r&quot;</span>,&amp;fd);CHKERRQ(ierr);
<a name="l00075"></a>00075   <span class="keywordflow">if</span> (!rank &amp;&amp; !fd) {
<a name="l00076"></a>00076     SETERRQ1(PETSC_ERR_FILE_OPEN,<span class="stringliteral">&quot;Cannot open %s\n&quot;</span>,fmesh);
<a name="l00077"></a>00077   }
<a name="l00078"></a>00078   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Opening file %s\n&quot;</span>,fmesh);
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   <span class="comment">/* read</span>
<a name="l00082"></a>00082 <span class="comment">     number of vertices,</span>
<a name="l00083"></a>00083 <span class="comment">     number of elements,</span>
<a name="l00084"></a>00084 <span class="comment">     number of vertex data,</span>
<a name="l00085"></a>00085 <span class="comment">     number of element data,</span>
<a name="l00086"></a>00086 <span class="comment">     number of model data</span>
<a name="l00087"></a>00087 <span class="comment">  */</span>
<a name="l00088"></a>00088   fscanf(fd,<span class="stringliteral">&quot;%i %i %i %i %i\n&quot;</span>,
<a name="l00089"></a>00089     &amp;n1,&amp;n2,&amp;n3,&amp;n4,&amp;n5
<a name="l00090"></a>00090   );
<a name="l00091"></a>00091   n_ele=n2;
<a name="l00092"></a>00092 
<a name="l00093"></a>00093   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Number of grid vertices: %i\n&quot;</span>,n1);
<a name="l00094"></a>00094   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Number of grid elements: %i\n&quot;</span>,n_ele);
<a name="l00095"></a>00095 
<a name="l00096"></a>00096   t_dnv=n3;
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Number of vertex data:   %i\n&quot;</span>,n3);
<a name="l00099"></a>00099   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Number of element data:  %i\n&quot;</span>,n4);
<a name="l00100"></a>00100   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Number of element data2: %i\n&quot;</span>,n5);
<a name="l00101"></a>00101 
<a name="l00102"></a>00102   <span class="comment">/* *************************************************************************</span>
<a name="l00103"></a>00103 <span class="comment">     Read in all vertices</span>
<a name="l00104"></a>00104 <span class="comment">  */</span>
<a name="l00105"></a>00105 
<a name="l00106"></a>00106   <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>==PETSC_NULL) {
<a name="l00107"></a>00107     flg=PETSC_FALSE;
<a name="l00108"></a>00108     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00109"></a>00109       <span class="stringliteral">&quot;Allocating array for vertices and reading their coordinates\n&quot;</span>);
<a name="l00110"></a>00110 
<a name="l00111"></a>00111     gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>=n1;
<a name="l00112"></a>00112     gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>=gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>;
<a name="l00113"></a>00113 
<a name="l00114"></a>00114     ierr = PetscMalloc(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>*<span class="keyword">sizeof</span>(PetscReal),&amp;gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>);CHKERRQ(ierr);
<a name="l00115"></a>00115   }
<a name="l00116"></a>00116   <span class="keywordflow">else</span> {
<a name="l00117"></a>00117     flg=PETSC_TRUE;
<a name="l00118"></a>00118     <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>!=n1) {
<a name="l00119"></a>00119       SETERRQ3(PETSC_ERR_FILE_UNEXPECTED,
<a name="l00120"></a>00120         <span class="stringliteral">&quot;Data in %s corrupt! Number of vertices does not agree with previously read mesh (%i != %i).\n&quot;</span>,
<a name="l00121"></a>00121         fmesh,gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,n1
<a name="l00122"></a>00122       );
<a name="l00123"></a>00123     }
<a name="l00124"></a>00124     <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>!=gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>) {
<a name="l00125"></a>00125       SETERRQ3(PETSC_ERR_FILE_UNEXPECTED,
<a name="l00126"></a>00126         <span class="stringliteral">&quot;Data in %s corrupt! Number of elements does not agree with previously read mesh (%i != %i).\n&quot;</span>,
<a name="l00127"></a>00127         fmesh,gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>,gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>
<a name="l00128"></a>00128       );
<a name="l00129"></a>00129     }
<a name="l00130"></a>00130   }
<a name="l00131"></a>00131 
<a name="l00132"></a>00132   <span class="comment">/* read data of all vertices */</span>
<a name="l00133"></a>00133   <span class="keywordflow">for</span> (i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>; i++) {
<a name="l00134"></a>00134 <span class="preprocessor">#ifdef PETSC_USE_SINGLE</span>
<a name="l00135"></a>00135 <span class="preprocessor"></span>    fscanf(fd,<span class="stringliteral">&quot;%i %f %f %f\n&quot;</span>,
<a name="l00136"></a>00136 #<span class="keywordflow">else</span>
<a name="l00137"></a>00137     fscanf(fd,<span class="stringliteral">&quot;%i %lf %lf %lf\n&quot;</span>,
<a name="l00138"></a>00138 #endif
<a name="l00139"></a>00139       &amp;<span class="keywordtype">id</span>,&amp;d1,&amp;d2,&amp;d3
<a name="l00140"></a>00140     );
<a name="l00141"></a>00141 
<a name="l00142"></a>00142     <span class="keywordtype">id</span>--;
<a name="l00143"></a>00143 
<a name="l00144"></a>00144     <span class="keywordflow">if</span> (flg==PETSC_FALSE) {
<a name="l00145"></a>00145       gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*<span class="keywordtype">id</span>+0]=d1;
<a name="l00146"></a>00146       gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*<span class="keywordtype">id</span>+1]=d2;
<a name="l00147"></a>00147       gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*<span class="keywordtype">id</span>+2]=d3;
<a name="l00148"></a>00148     }
<a name="l00149"></a>00149     <span class="keywordflow">else</span> {
<a name="l00150"></a>00150       <span class="keywordflow">if</span> (PetscAbsReal(d1)&gt;<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>) {
<a name="l00151"></a>00151         <span class="keywordflow">if</span> (PetscAbsReal((gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*<span class="keywordtype">id</span>+0]-d1)/d1) &gt; 1e-4)
<a name="l00152"></a>00152         {
<a name="l00153"></a>00153           PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Data in %s corrupt!\n&quot;</span>,fmesh);
<a name="l00154"></a>00154           SETERRQ3(PETSC_ERR_FILE_UNEXPECTED,
<a name="l00155"></a>00155             <span class="stringliteral">&quot;x-coordinates of vertex %i does not agree with previously read mesh (%g != %g).\n&quot;</span>,
<a name="l00156"></a>00156             i,
<a name="l00157"></a>00157             gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*<span class="keywordtype">id</span>+0],
<a name="l00158"></a>00158             d1
<a name="l00159"></a>00159           );
<a name="l00160"></a>00160         }
<a name="l00161"></a>00161       }
<a name="l00162"></a>00162       <span class="keywordflow">if</span> (PetscAbsReal(d2)&gt;<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>) {
<a name="l00163"></a>00163         <span class="keywordflow">if</span> (PetscAbsReal((gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*<span class="keywordtype">id</span>+1]-d2)/d2) &gt; 1e-4)
<a name="l00164"></a>00164         {
<a name="l00165"></a>00165           PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Data in %s corrupt!\n&quot;</span>,fmesh);
<a name="l00166"></a>00166           SETERRQ3(PETSC_ERR_FILE_UNEXPECTED,
<a name="l00167"></a>00167             <span class="stringliteral">&quot;y-coordinates of vertex %i does not agree with previously read mesh (%g != %g).\n&quot;</span>,
<a name="l00168"></a>00168             i,
<a name="l00169"></a>00169             gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*<span class="keywordtype">id</span>+1],
<a name="l00170"></a>00170             d2
<a name="l00171"></a>00171           );
<a name="l00172"></a>00172         }
<a name="l00173"></a>00173       }
<a name="l00174"></a>00174       <span class="keywordflow">if</span> (PetscAbsReal(d3)&gt;<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>) {
<a name="l00175"></a>00175         <span class="keywordflow">if</span> (PetscAbsReal((gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*<span class="keywordtype">id</span>+2]-d3)/d3) &gt; 1e-4)
<a name="l00176"></a>00176         {
<a name="l00177"></a>00177           PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Data in %s corrupt!\n&quot;</span>,fmesh);
<a name="l00178"></a>00178           SETERRQ3(PETSC_ERR_FILE_UNEXPECTED,
<a name="l00179"></a>00179             <span class="stringliteral">&quot;z-coordinates of vertex %i does not agree with previously read mesh (%g != %g).\n&quot;</span>,
<a name="l00180"></a>00180             i,
<a name="l00181"></a>00181             gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*<span class="keywordtype">id</span>+2],
<a name="l00182"></a>00182             d2
<a name="l00183"></a>00183           );
<a name="l00184"></a>00184         }
<a name="l00185"></a>00185       }
<a name="l00186"></a>00186     }
<a name="l00187"></a>00187   }
<a name="l00188"></a>00188 
<a name="l00189"></a>00189   <span class="comment">/* *************************************************************************</span>
<a name="l00190"></a>00190 <span class="comment">     Read in all elements</span>
<a name="l00191"></a>00191 <span class="comment">  */</span>
<a name="l00192"></a>00192 
<a name="l00193"></a>00193   <span class="keywordflow">if</span> (gdata-&gt;elevert==PETSC_NULL) {
<a name="l00194"></a>00194     flg=PETSC_FALSE;
<a name="l00195"></a>00195     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Allocating array for element connectivity and reading it\n&quot;</span>);
<a name="l00196"></a>00196 
<a name="l00197"></a>00197     gdata-&gt;n_ele=n_ele;
<a name="l00198"></a>00198     gdata-&gt;ln_ele=gdata-&gt;n_ele;
<a name="l00199"></a>00199 
<a name="l00200"></a>00200     gdata-&gt;n_prop=0;
<a name="l00201"></a>00201 
<a name="l00202"></a>00202     ierr = PetscMalloc(<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*gdata-&gt;n_ele*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;gdata-&gt;elevert);CHKERRQ(ierr);
<a name="l00203"></a>00203     ierr = PetscMalloc(gdata-&gt;n_ele*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;gdata-&gt;eleprop);CHKERRQ(ierr);
<a name="l00204"></a>00204   }
<a name="l00205"></a>00205   <span class="keywordflow">else</span> {
<a name="l00206"></a>00206     flg=PETSC_TRUE;
<a name="l00207"></a>00207     assert(gdata-&gt;n_ele==n_ele || n_ele==0);
<a name="l00208"></a>00208     assert(gdata-&gt;ln_ele==gdata-&gt;n_ele);
<a name="l00209"></a>00209   }
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 
<a name="l00212"></a>00212   <span class="keywordflow">for</span> (i=0; i&lt;n_ele; i++) {
<a name="l00213"></a>00213     fscanf(fd,<span class="stringliteral">&quot;%i %i tet %i %i %i %i\n&quot;</span>,
<a name="l00214"></a>00214       &amp;<span class="keywordtype">id</span>,&amp;a1,&amp;n1,&amp;n2,&amp;n3,&amp;n4
<a name="l00215"></a>00215     );
<a name="l00216"></a>00216 
<a name="l00217"></a>00217     <span class="comment">/* our numbering starts with 0, not 1 */</span>
<a name="l00218"></a>00218     <span class="keywordtype">id</span>--;
<a name="l00219"></a>00219 
<a name="l00220"></a>00220     <span class="keywordflow">if</span> (a1&lt;1) {
<a name="l00221"></a>00221       SETERRQ3(PETSC_ERR_FILE_UNEXPECTED,
<a name="l00222"></a>00222         <span class="stringliteral">&quot;Data in %s corrupt! Property of element %i is %i, but has to be &gt;0! Exiting!\n&quot;</span>,
<a name="l00223"></a>00223         fmesh,i,a1
<a name="l00224"></a>00224       );
<a name="l00225"></a>00225     }
<a name="l00226"></a>00226 
<a name="l00227"></a>00227     <span class="keywordflow">if</span> (flg==PETSC_FALSE) {
<a name="l00228"></a>00228       gdata-&gt;n_prop=PetscMax(gdata-&gt;n_prop,a1);
<a name="l00229"></a>00229       <span class="comment">/* internal property ids start with 0 !!! */</span>
<a name="l00230"></a>00230       gdata-&gt;eleprop[id]=--a1;
<a name="l00231"></a>00231 
<a name="l00232"></a>00232       gdata-&gt;elevert[<span class="keywordtype">id</span>*<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>+0]=--n1;
<a name="l00233"></a>00233       gdata-&gt;elevert[<span class="keywordtype">id</span>*<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>+1]=--n2;
<a name="l00234"></a>00234       gdata-&gt;elevert[<span class="keywordtype">id</span>*<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>+2]=--n3;
<a name="l00235"></a>00235       gdata-&gt;elevert[<span class="keywordtype">id</span>*<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>+3]=--n4;
<a name="l00236"></a>00236     }
<a name="l00237"></a>00237     <span class="keywordflow">else</span> {
<a name="l00238"></a>00238       <span class="comment">/* internal property ids start with 0 !!! */</span>
<a name="l00239"></a>00239       assert(gdata-&gt;eleprop[<span class="keywordtype">id</span>]==--a1);
<a name="l00240"></a>00240 
<a name="l00241"></a>00241       assert(gdata-&gt;elevert[<span class="keywordtype">id</span>*<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>+0]==--n1);
<a name="l00242"></a>00242       assert(gdata-&gt;elevert[<span class="keywordtype">id</span>*<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>+1]==--n2);
<a name="l00243"></a>00243       assert(gdata-&gt;elevert[<span class="keywordtype">id</span>*<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>+2]==--n3);
<a name="l00244"></a>00244       assert(gdata-&gt;elevert[<span class="keywordtype">id</span>*<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>+3]==--n4);
<a name="l00245"></a>00245     }
<a name="l00246"></a>00246   }
<a name="l00247"></a>00247 
<a name="l00248"></a>00248   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Number of element prop.: %i\n&quot;</span>,gdata-&gt;n_prop);
<a name="l00249"></a>00249 
<a name="l00250"></a>00250   <span class="keywordflow">if</span> (col&lt;=0) {
<a name="l00251"></a>00251     PetscFClose(PETSC_COMM_WORLD,fd);
<a name="l00252"></a>00252     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00253"></a>00253   }
<a name="l00254"></a>00254 
<a name="l00255"></a>00255   <span class="comment">/* *************************************************************************</span>
<a name="l00256"></a>00256 <span class="comment">     Read vertex data</span>
<a name="l00257"></a>00257 <span class="comment">  */</span>
<a name="l00258"></a>00258 
<a name="l00259"></a>00259   <span class="comment">/* read number of components of vertex data */</span>
<a name="l00260"></a>00260   fscanf(fd,<span class="stringliteral">&quot;%i\n&quot;</span>,&amp;a1);
<a name="l00261"></a>00261   assert(a1==t_dnv);
<a name="l00262"></a>00262 
<a name="l00263"></a>00263   <span class="keywordflow">if</span> (a1&lt;col+2) {
<a name="l00264"></a>00264     SETERRQ3(PETSC_ERR_FILE_UNEXPECTED,
<a name="l00265"></a>00265       <span class="stringliteral">&quot;Data in %s corrupt! Cannot read data from column %i. Only %i data columns found! Exiting!\n&quot;</span>,
<a name="l00266"></a>00266       fmesh,col,a1
<a name="l00267"></a>00267     );
<a name="l00268"></a>00268   }
<a name="l00269"></a>00269 
<a name="l00270"></a>00270   <span class="comment">/* read remainder of this line */</span>
<a name="l00271"></a>00271   fgets(msg,256,fd);
<a name="l00272"></a>00272 
<a name="l00273"></a>00273   <span class="comment">/* we assume that all components have size 1 ! */</span>
<a name="l00274"></a>00274   <span class="keywordflow">for</span> (i=0; i&lt;t_dnv; i++) {
<a name="l00275"></a>00275     fgets(msg,256,fd);
<a name="l00276"></a>00276     <span class="keywordflow">if</span> ((col-1)&lt;=i &amp;&amp; i&lt;=(col+2-1)) {
<a name="l00277"></a>00277       PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;reading: %s&quot;</span>,msg);
<a name="l00278"></a>00278     }
<a name="l00279"></a>00279   }
<a name="l00280"></a>00280 
<a name="l00281"></a>00281   <span class="keywordflow">for</span> (i=0; i&lt;gdata-&gt;n_vert; i++) {
<a name="l00282"></a>00282     <span class="comment">/* read id */</span>
<a name="l00283"></a>00283     fscanf(fd,<span class="stringliteral">&quot;%i&quot;</span>,&amp;<span class="keywordtype">id</span>);
<a name="l00284"></a>00284 
<a name="l00285"></a>00285     <span class="comment">/* skip useless columns */</span>
<a name="l00286"></a>00286     <span class="keywordflow">for</span> (j=0; j&lt;col-1; j++) {
<a name="l00287"></a>00287 <span class="preprocessor">#ifdef PETSC_USE_SINGLE</span>
<a name="l00288"></a>00288 <span class="preprocessor"></span>      <span class="keywordflow">if</span> (fscanf(fd,<span class="stringliteral">&quot;%f&quot;</span>,&amp;d1)!=1) {
<a name="l00289"></a>00289 <span class="preprocessor">#else</span>
<a name="l00290"></a>00290 <span class="preprocessor"></span>      <span class="keywordflow">if</span> (fscanf(fd,<span class="stringliteral">&quot;%lf&quot;</span>,&amp;d1)!=1) {
<a name="l00291"></a>00291 <span class="preprocessor">#endif</span>
<a name="l00292"></a>00292 <span class="preprocessor"></span>        SETERRQ3(PETSC_ERR_FILE_UNEXPECTED,
<a name="l00293"></a>00293           <span class="stringliteral">&quot;Data in %s corrupt! Cannot read data from column %i. Only %i data columns found! Exiting!\n&quot;</span>,
<a name="l00294"></a>00294           fmesh,col,j
<a name="l00295"></a>00295         );
<a name="l00296"></a>00296       }
<a name="l00297"></a>00297     }
<a name="l00298"></a>00298 
<a name="l00299"></a>00299     <span class="comment">/* read data */</span>
<a name="l00300"></a>00300 <span class="preprocessor">#ifdef PETSC_USE_SINGLE</span>
<a name="l00301"></a>00301 <span class="preprocessor"></span>    fscanf(fd,<span class="stringliteral">&quot;%f %f %f&quot;</span>,&amp;d1,&amp;d2,&amp;d3);
<a name="l00302"></a>00302 <span class="preprocessor">#else</span>
<a name="l00303"></a>00303 <span class="preprocessor"></span>    fscanf(fd,<span class="stringliteral">&quot;%lf %lf %lf&quot;</span>,&amp;d1,&amp;d2,&amp;d3);
<a name="l00304"></a>00304 <span class="preprocessor">#endif</span>
<a name="l00305"></a>00305 <span class="preprocessor"></span>    <span class="comment">/* read remainder of this line */</span>
<a name="l00306"></a>00306     fgets(msg,256,fd);
<a name="l00307"></a>00307 
<a name="l00308"></a>00308     <span class="comment">/* our numbering starts with 0, not 1 */</span>
<a name="l00309"></a>00309     <span class="keywordtype">id</span>--;
<a name="l00310"></a>00310 
<a name="l00311"></a>00311     ierr = VecSetValue(Vdest,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*<span class="keywordtype">id</span>+0,d1,INSERT_VALUES);CHKERRQ(ierr);
<a name="l00312"></a>00312     ierr = VecSetValue(Vdest,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*<span class="keywordtype">id</span>+1,d2,INSERT_VALUES);CHKERRQ(ierr);
<a name="l00313"></a>00313     ierr = VecSetValue(Vdest,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*<span class="keywordtype">id</span>+2,d3,INSERT_VALUES);CHKERRQ(ierr);
<a name="l00314"></a>00314   }
<a name="l00315"></a>00315 
<a name="l00316"></a>00316   ierr = VecAssemblyBegin(Vdest);CHKERRQ(ierr);
<a name="l00317"></a>00317   ierr = VecAssemblyEnd(Vdest);CHKERRQ(ierr);
<a name="l00318"></a>00318 
<a name="l00319"></a>00319   ierr = PetscFClose(PETSC_COMM_WORLD,fd);CHKERRQ(ierr);
<a name="l00320"></a>00320 
<a name="l00321"></a>00321 
<a name="l00322"></a>00322   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00323"></a>00323 }
<a name="l00324"></a>00324 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

